#!/usr/bin/env python

from simplex import *
import sys, time

try:
    separator = sys.argv.index("--")
    filename, numeric, interval = sys.argv[1:4]
    fields = map(int, sys.argv[4:separator])
    terms = groups(sys.argv[separator+1:], len(fields))
except (IndexError, ValueError):
    print >>sys.stderr, "Usage: %s <filename> <interval> <field>... -- <term value>..." % sys.argv[0]
    sys.exit(1)

f = open(filename)
accessor = DelimitedRecord(fields, numeric=(numeric == "true"))
try:
    t = time.time()
    l = make_index(f, accessor.get_key, int(interval))
    print "Indexed in %s seconds." % (time.time() - t)

    # Now use the index.

    for term in terms:
        t = time.time()
        line = find_with_index(f, accessor.get_key, l, accessor.convert(term))
        if line:
            print "Found (at %s seconds)...\n%s" % (time.time() - t, line)

finally:
    f.close()

# vim: tabstop=4 expandtab shiftwidth=4
